diff --git a/salt/transport/tcp.py b/salt/transport/tcp.py
index 12ef24e86f..9b2f6641ab 100644
--- a/salt/transport/tcp.py
+++ b/salt/transport/tcp.py
@@ -16,6 +16,7 @@ import sys
 import time
 import threading
 import traceback
+import uuid
 import weakref
 
 # Import Salt Libs
@@ -339,12 +340,17 @@ class AsyncTCPReqChannel(salt.transport.client.ReqChannel):
 
     def _package_load(self, load):
         return {
-            'enc': self.crypt,
-            'load': load,
+            "enc": self.crypt,
+            "load": load,
+            "version": 2,
         }
 
     @salt.ext.tornado.gen.coroutine
-    def crypted_transfer_decode_dictentry(self, load, dictkey=None, tries=3, timeout=60):
+    def crypted_transfer_decode_dictentry(
+        self, load, dictkey=None, tries=3, timeout=60
+    ):
+        nonce = uuid.uuid4().hex
+        load["nonce"] = nonce
         if not self.auth.authenticated:
             yield self.auth.authenticate()
         ret = yield self.message_client.send(self._package_load(self.auth.crypticle.dumps(load)), timeout=timeout)
@@ -353,12 +359,30 @@ class AsyncTCPReqChannel(salt.transport.client.ReqChannel):
             aes = key.private_decrypt(ret['key'], RSA.pkcs1_oaep_padding)
         else:
             cipher = PKCS1_OAEP.new(key)
-            aes = cipher.decrypt(ret['key'])
+            aes = cipher.decrypt(ret["key"])
+
+        # Decrypt using the public key.
         pcrypt = salt.crypt.Crypticle(self.opts, aes)
-        data = pcrypt.loads(ret[dictkey])
-        if six.PY3:
-            data = salt.transport.frame.decode_embedded_strs(data)
-        raise salt.ext.tornado.gen.Return(data)
+        signed_msg = pcrypt.loads(ret[dictkey])
+
+        # Validate the master's signature.
+        master_pubkey_path = os.path.join(self.opts["pki_dir"], "minion_master.pub")
+        if not salt.crypt.verify_signature(
+            master_pubkey_path, signed_msg["data"], signed_msg["sig"]
+        ):
+            raise salt.crypt.AuthenticationError(
+                "Pillar payload signature failed to validate."
+            )
+
+        # Make sure the signed key matches the key we used to decrypt the data.
+        data = salt.payload.Serial({}).loads(signed_msg["data"])
+        if data["key"] != ret["key"]:
+            raise salt.crypt.AuthenticationError("Key verification failed.")
+
+        # Validate the nonce.
+        if data["nonce"] != nonce:
+            raise salt.crypt.AuthenticationError("Pillar nonce verification failed.")
+        raise salt.ext.tornado.gen.Return(data["pillar"])
 
     @salt.ext.tornado.gen.coroutine
     def _crypted_transfer(self, load, tries=3, timeout=60):
@@ -368,6 +392,10 @@ class AsyncTCPReqChannel(salt.transport.client.ReqChannel):
         Indeed, we can fail too early in case of a master restart during a
         minion state execution call
         '''
+        nonce = uuid.uuid4().hex
+        if load and isinstance(load, dict):
+            load["nonce"] = nonce
+
         @salt.ext.tornado.gen.coroutine
         def _do_transfer():
             data = yield self.message_client.send(self._package_load(self.auth.crypticle.dumps(load)),
@@ -378,9 +406,8 @@ class AsyncTCPReqChannel(salt.transport.client.ReqChannel):
             # communication, we do not subscribe to return events, we just
             # upload the results to the master
             if data:
-                data = self.auth.crypticle.loads(data)
-                if six.PY3:
-                    data = salt.transport.frame.decode_embedded_strs(data)
+                data = self.auth.crypticle.loads(data, nonce=nonce)
+                data = salt.transport.frame.decode_embedded_strs(data)
             raise salt.ext.tornado.gen.Return(data)
 
         if not self.auth.authenticated:
@@ -448,8 +475,9 @@ class AsyncTCPPubChannel(salt.transport.mixins.auth.AESPubClientMixin, salt.tran
 
     def _package_load(self, load):
         return {
-            'enc': self.crypt,
-            'load': load,
+            "enc": self.crypt,
+            "load": load,
+            "version": 2,
         }
 
     @salt.ext.tornado.gen.coroutine
@@ -719,13 +747,31 @@ class TCPReqServerChannel(salt.transport.mixins.auth.AESReqServerMixin, salt.tra
                 stream.send(self.serial.dumps('bad load: id {0} is not a string'.format(id_)))
                 raise salt.ext.tornado.gen.Return()
 
+            version = 0
+            if "version" in payload:
+                version = payload["version"]
+
+            sign_messages = False
+            if version > 1:
+                sign_messages = True
+
             # intercept the "_auth" commands, since the main daemon shouldn't know
             # anything about our key auth
-            if payload['enc'] == 'clear' and payload.get('load', {}).get('cmd') == '_auth':
-                yield stream.write(salt.transport.frame.frame_msg(
-                    self._auth(payload['load']), header=header))
+            if (
+                payload["enc"] == "clear"
+                and payload.get("load", {}).get("cmd") == "_auth"
+            ):
+                yield stream.write(
+                    salt.transport.frame.frame_msg(
+                        self._auth(payload["load"], sign_messages), header=header
+                    )
+                )
                 raise salt.ext.tornado.gen.Return()
 
+            nonce = None
+            if version > 1:
+                nonce = payload["load"].pop("nonce", None)
+
             # TODO: test
             try:
                 ret, req_opts = yield self.payload_handler(payload)
@@ -739,13 +785,21 @@ class TCPReqServerChannel(salt.transport.mixins.auth.AESReqServerMixin, salt.tra
             req_fun = req_opts.get('fun', 'send')
             if req_fun == 'send_clear':
                 stream.write(salt.transport.frame.frame_msg(ret, header=header))
-            elif req_fun == 'send':
-                stream.write(salt.transport.frame.frame_msg(self.crypticle.dumps(ret), header=header))
-            elif req_fun == 'send_private':
-                stream.write(salt.transport.frame.frame_msg(self._encrypt_private(ret,
-                                                             req_opts['key'],
-                                                             req_opts['tgt'],
-                                                             ), header=header))
+            elif req_fun == "send":
+                stream.write(
+                    salt.transport.frame.frame_msg(
+                        self.crypticle.dumps(ret, nonce), header=header
+                    )
+                )
+            elif req_fun == "send_private":
+                stream.write(
+                    salt.transport.frame.frame_msg(
+                        self._encrypt_private(
+                            ret, req_opts["key"], req_opts["tgt"], nonce, sign_messages,
+                        ),
+                        header=header,
+                    )
+                )
             else:
                 log.error('Unknown req_fun %s', req_fun)
                 # always attempt to return an error to the minion
@@ -1274,8 +1328,9 @@ class PubServer(salt.ext.tornado.tcpserver.TCPServer, object):
     '''
     TCP publisher
     '''
-    def __init__(self, opts, io_loop=None):
-        super(PubServer, self).__init__(ssl_options=opts.get('ssl'))
+
+    def __init__(self, opts, io_loop=None, pack_publish=lambda _: _):
+        super().__init__(ssl_options=opts.get("ssl"))
         self.io_loop = io_loop
         self.opts = opts
         self._closing = False
@@ -1300,6 +1355,10 @@ class PubServer(salt.ext.tornado.tcpserver.TCPServer, object):
                 opts=self.opts,
                 listen=False
             )
+        self._pack_publish = pack_publish
+
+    def pack_publish(self, payload):
+        return self._pack_publish(payload)
 
     def close(self):
         if self._closing:
@@ -1406,8 +1465,9 @@ class PubServer(salt.ext.tornado.tcpserver.TCPServer, object):
     # TODO: ACK the publish through IPC
     @salt.ext.tornado.gen.coroutine
     def publish_payload(self, package, _):
-        log.debug('TCP PubServer sending payload: %s', package)
-        payload = salt.transport.frame.frame_msg(package['payload'])
+        log.debug("TCP PubServer sending payload: %s", package)
+        package = self.pack_publish(package)
+        payload = salt.transport.frame.frame_msg(package["payload"])
 
         to_remove = []
         if 'topic_lst' in package:
@@ -1482,7 +1542,9 @@ class TCPPubServerChannel(salt.transport.server.PubServerChannel):
             self.io_loop = salt.ext.tornado.ioloop.IOLoop.current()
 
         # Spin up the publisher
-        pub_server = PubServer(self.opts, io_loop=self.io_loop)
+        pub_server = PubServer(
+            self.opts, io_loop=self.io_loop, pack_publish=self.pack_publish
+        )
         sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
         sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
         _set_tcp_keepalive(sock, self.opts)
@@ -1523,30 +1585,20 @@ class TCPPubServerChannel(salt.transport.server.PubServerChannel):
         '''
         process_manager.add_process(self._publish_daemon, kwargs=kwargs)
 
-    def publish(self, load):
-        '''
+    def pack_publish(self, load):
+        """
         Publish "load" to minions
-        '''
-        payload = {'enc': 'aes'}
-
-        crypticle = salt.crypt.Crypticle(self.opts, salt.master.SMaster.secrets['aes']['secret'].value)
-        payload['load'] = crypticle.dumps(load)
-        if self.opts['sign_pub_messages']:
-            master_pem_path = os.path.join(self.opts['pki_dir'], 'master.pem')
-            log.debug("Signing data packet")
-            payload['sig'] = salt.crypt.sign_message(master_pem_path, payload['load'])
-        # Use the Salt IPC server
-        if self.opts.get('ipc_mode', '') == 'tcp':
-            pull_uri = int(self.opts.get('tcp_master_publish_pull', 4514))
-        else:
-            pull_uri = os.path.join(self.opts['sock_dir'], 'publish_pull.ipc')
-        # TODO: switch to the actual asynchronous interface
-        #pub_sock = salt.transport.ipc.IPCMessageClient(self.opts, io_loop=self.io_loop)
-        pub_sock = salt.utils.asynchronous.SyncWrapper(
-            salt.transport.ipc.IPCMessageClient,
-            (pull_uri,)
+        """
+        payload = {"enc": "aes"}
+        load["serial"] = salt.master.SMaster.get_serial()
+        crypticle = salt.crypt.Crypticle(
+            self.opts, salt.master.SMaster.secrets["aes"]["secret"].value
         )
-        pub_sock.connect()
+        payload["load"] = crypticle.dumps(load)
+        if self.opts["sign_pub_messages"]:
+            master_pem_path = os.path.join(self.opts["pki_dir"], "master.pem")
+            log.debug("Signing data packet")
+            payload["sig"] = salt.crypt.sign_message(master_pem_path, payload["load"])
 
         int_payload = {'payload': self.serial.dumps(payload)}
 
@@ -1562,6 +1614,23 @@ class TCPPubServerChannel(salt.transport.server.PubServerChannel):
                 # Send list of miions thru so zmq can target them
                 int_payload['topic_lst'] = match_ids
             else:
-                int_payload['topic_lst'] = load['tgt']
+                int_payload["topic_lst"] = load["tgt"]
+        return int_payload
+
+    def publish(self, load):
+        """
+        Publish "load" to minions
+        """
         # Send it over IPC!
-        pub_sock.send(int_payload)
+        # Use the Salt IPC server
+        # TODO: switch to the actual asynchronous interface
+        # pub_sock = salt.transport.ipc.IPCMessageClient(self.opts, io_loop=self.io_loop)
+        if self.opts.get("ipc_mode", "") == "tcp":
+            pull_uri = int(self.opts.get("tcp_master_publish_pull", 4514))
+        else:
+            pull_uri = os.path.join(self.opts["sock_dir"], "publish_pull.ipc")
+        pub_sock = salt.utils.asynchronous.SyncWrapper(
+            salt.transport.ipc.IPCMessageClient, (pull_uri,), loop_kwarg="io_loop",
+        )
+        pub_sock.connect()
+        pub_sock.send(load)
diff --git a/salt/transport/zeromq.py b/salt/transport/zeromq.py
index a5844e9132..540abb8853 100644
--- a/salt/transport/zeromq.py
+++ b/salt/transport/zeromq.py
@@ -13,6 +13,8 @@ import signal
 import socket
 import hashlib
 import logging
+import signal
+import uuid
 import weakref
 import threading
 from random import randint
@@ -21,6 +23,7 @@ from random import randint
 import salt.auth
 import salt.crypt
 import salt.log.setup
+import salt.utils.crypt
 import salt.utils.event
 import salt.utils.files
 import salt.utils.minions
@@ -65,6 +68,7 @@ except ImportError:
     except ImportError:
         from Crypto.Cipher import PKCS1_OAEP
 
+
 log = logging.getLogger(__name__)
 
 
@@ -79,11 +83,12 @@ def _get_master_uri(master_ip,
     rc = zmq_connect(socket, "tcp://192.168.1.17:5555;192.168.1.1:5555"); assert (rc == 0);
     Source: http://api.zeromq.org/4-1:zmq-tcp
     '''
-    from salt.utils.zeromq import ip_bracket
 
-    master_uri = 'tcp://{master_ip}:{master_port}'.format(
-                  master_ip=ip_bracket(master_ip), master_port=master_port)
+    from salt.utils.zeromq import ip_bracket
 
+    master_uri = "tcp://{master_ip}:{master_port}".format(
+        master_ip=ip_bracket(master_ip), master_port=master_port
+    )
     if source_ip or source_port:
         if LIBZMQ_VERSION_INFO >= (4, 1, 6) and ZMQ_VERSION_INFO >= (16, 0, 1):
             # The source:port syntax for ZeroMQ has been added in libzmq 4.1.6
@@ -292,23 +297,30 @@ class AsyncZeroMQReqChannel(salt.transport.client.ReqChannel):
 
     def _package_load(self, load):
         return {
-            'enc': self.crypt,
-            'load': load,
+            "enc": self.crypt,
+            "load": load,
+            "version": 2,
         }
 
     @salt.ext.tornado.gen.coroutine
-    def crypted_transfer_decode_dictentry(self, load, dictkey=None, tries=3, timeout=60):
+    def crypted_transfer_decode_dictentry(
+        self, load, dictkey=None, tries=3, timeout=60
+    ):
+        nonce = uuid.uuid4().hex
+        load["nonce"] = nonce
         if not self.auth.authenticated:
             # Return control back to the caller, continue when authentication succeeds
             yield self.auth.authenticate()
-        # Return control to the caller. When send() completes, resume by populating ret with the Future.result
+
+        # Return control to the caller. When send() completes, resume by
+        # populating ret with the Future.result
         ret = yield self.message_client.send(
             self._package_load(self.auth.crypticle.dumps(load)),
             timeout=timeout,
             tries=tries,
         )
-        key = self.auth.get_keys()
-        if 'key' not in ret:
+
+        if "key" not in ret:
             # Reauth in the case our key is deleted on the master side.
             yield self.auth.authenticate()
             ret = yield self.message_client.send(
@@ -316,17 +328,37 @@ class AsyncZeroMQReqChannel(salt.transport.client.ReqChannel):
                 timeout=timeout,
                 tries=tries,
             )
+
+        key = self.auth.get_keys()
         if HAS_M2:
             aes = key.private_decrypt(ret['key'],
                                       RSA.pkcs1_oaep_padding)
         else:
             cipher = PKCS1_OAEP.new(key)
-            aes = cipher.decrypt(ret['key'])
+            aes = cipher.decrypt(ret["key"])
+
+        # Decrypt using the public key.
         pcrypt = salt.crypt.Crypticle(self.opts, aes)
-        data = pcrypt.loads(ret[dictkey])
-        if six.PY3:
-            data = salt.transport.frame.decode_embedded_strs(data)
-        raise salt.ext.tornado.gen.Return(data)
+        signed_msg = pcrypt.loads(ret[dictkey])
+
+        # Validate the master's signature.
+        master_pubkey_path = os.path.join(self.opts["pki_dir"], "minion_master.pub")
+        if not salt.crypt.verify_signature(
+            master_pubkey_path, signed_msg["data"], signed_msg["sig"]
+        ):
+            raise salt.crypt.AuthenticationError(
+                "Pillar payload signature failed to validate."
+            )
+
+        # Make sure the signed key matches the key we used to decrypt the data.
+        data = salt.payload.Serial({}).loads(signed_msg["data"])
+        if data["key"] != ret["key"]:
+            raise salt.crypt.AuthenticationError("Key verification failed.")
+
+        # Validate the nonce.
+        if data["nonce"] != nonce:
+            raise salt.crypt.AuthenticationError("Pillar nonce verification failed.")
+        raise salt.ext.tornado.gen.Return(data["pillar"])
 
     @salt.ext.tornado.gen.coroutine
     def _crypted_transfer(self, load, tries=3, timeout=60, raw=False):
@@ -343,6 +375,10 @@ class AsyncZeroMQReqChannel(salt.transport.client.ReqChannel):
         :param int tries: The number of times to make before failure
         :param int timeout: The number of seconds on a response before failing
         '''
+        nonce = uuid.uuid4().hex
+        if load and isinstance(load, dict):
+            load["nonce"] = nonce
+
         @salt.ext.tornado.gen.coroutine
         def _do_transfer():
             # Yield control to the caller. When send() completes, resume by populating data with the Future.result
@@ -356,7 +392,7 @@ class AsyncZeroMQReqChannel(salt.transport.client.ReqChannel):
             # communication, we do not subscribe to return events, we just
             # upload the results to the master
             if data:
-                data = self.auth.crypticle.loads(data, raw)
+                data = self.auth.crypticle.loads(data, raw, nonce)
             if six.PY3 and not raw:
                 data = salt.transport.frame.decode_embedded_strs(data)
             raise salt.ext.tornado.gen.Return(data)
@@ -774,12 +810,24 @@ class ZeroMQReqServerChannel(salt.transport.mixins.auth.AESReqServerMixin,
             stream.send(self.serial.dumps('bad load: id {0} is not a string'.format(id_)))
             raise salt.ext.tornado.gen.Return()
 
+        version = 0
+        if "version" in payload:
+            version = payload["version"]
+
+        sign_messages = False
+        if version > 1:
+            sign_messages = True
+
         # intercept the "_auth" commands, since the main daemon shouldn't know
         # anything about our key auth
-        if payload['enc'] == 'clear' and payload.get('load', {}).get('cmd') == '_auth':
-            stream.send(self.serial.dumps(self._auth(payload['load'])))
+        if payload["enc"] == "clear" and payload.get("load", {}).get("cmd") == "_auth":
+            stream.send(self.serial.dumps(self._auth(payload["load"], sign_messages)))
             raise salt.ext.tornado.gen.Return()
 
+        nonce = None
+        if version > 1:
+            nonce = payload["load"].pop("nonce", None)
+
         # TODO: test
         try:
             # Take the payload_handler function that was registered when we created the channel
@@ -794,13 +842,16 @@ class ZeroMQReqServerChannel(salt.transport.mixins.auth.AESReqServerMixin,
         req_fun = req_opts.get('fun', 'send')
         if req_fun == 'send_clear':
             stream.send(self.serial.dumps(ret))
-        elif req_fun == 'send':
-            stream.send(self.serial.dumps(self.crypticle.dumps(ret)))
-        elif req_fun == 'send_private':
-            stream.send(self.serial.dumps(self._encrypt_private(ret,
-                                                                req_opts['key'],
-                                                                req_opts['tgt'],
-                                                                )))
+        elif req_fun == "send":
+            stream.send(self.serial.dumps(self.crypticle.dumps(ret, nonce)))
+        elif req_fun == "send_private":
+            stream.send(
+                self.serial.dumps(
+                    self._encrypt_private(
+                        ret, req_opts["key"], req_opts["tgt"], nonce, sign_messages,
+                    )
+                )
+            )
         else:
             log.error('Unknown req_fun %s', req_fun)
             # always attempt to return an error to the minion
@@ -878,6 +929,7 @@ class ZeroMQPubServerChannel(salt.transport.server.PubServerChannel):
         if log_queue:
             salt.log.setup.set_multiprocessing_logging_queue(log_queue)
             salt.log.setup.setup_multiprocessing_logging(log_queue)
+        salt.utils.crypt.reinit_crypto()
 
         # Set up the context
         context = zmq.Context(1)
@@ -929,7 +981,9 @@ class ZeroMQPubServerChannel(salt.transport.server.PubServerChannel):
                 try:
                     log.debug('Publish daemon getting data from puller %s', pull_uri)
                     package = pull_sock.recv()
-                    log.debug('Publish daemon received payload. size=%d', len(package))
+                    log.debug("Publish daemon received payload. size=%d", len(package))
+                    load = salt.payload.Serial({}).loads(package)
+                    package = self.pack_publish(load)
 
                     unpacked_package = salt.payload.unpackage(package)
                     if six.PY3:
@@ -1012,17 +1066,20 @@ class ZeroMQPubServerChannel(salt.transport.server.PubServerChannel):
             self.pub_close()
         ctx = zmq.Context.instance()
         self._sock_data.sock = ctx.socket(zmq.PUSH)
-        self.pub_sock.setsockopt(zmq.LINGER, -1)
-        if self.opts.get('ipc_mode', '') == 'tcp':
-            pull_uri = 'tcp://127.0.0.1:{0}'.format(
-                self.opts.get('tcp_master_publish_pull', 4514)
-                )
+        self._sock_data.sock.setsockopt(zmq.LINGER, -1)
+        self._sock_data.sock.setsockopt(zmq.SNDHWM, self.opts.get("pub_hwm", 1000))
+        self._sock_data.sock.setsockopt(zmq.RCVHWM, self.opts.get("pub_hwm", 1000))
+        self._sock_data.sock.setsockopt(zmq.BACKLOG, self.opts.get("zmq_backlog", 1000))
+        if self.opts.get("ipc_mode", "") == "tcp":
+            pull_uri = "tcp://127.0.0.1:{}".format(
+                self.opts.get("tcp_master_publish_pull", 4514)
+            )
         else:
             pull_uri = 'ipc://{0}'.format(
                 os.path.join(self.opts['sock_dir'], 'publish_pull.ipc')
                 )
         log.debug("Connecting to pub server: %s", pull_uri)
-        self.pub_sock.connect(pull_uri)
+        self._sock_data.sock.connect(pull_uri)
         return self._sock_data.sock
 
     def pub_close(self):
@@ -1032,20 +1089,23 @@ class ZeroMQPubServerChannel(salt.transport.server.PubServerChannel):
         '''
         if hasattr(self._sock_data, 'sock'):
             self._sock_data.sock.close()
-            delattr(self._sock_data, 'sock')
+            self._sock_data.sock = None
 
-    def publish(self, load):
-        '''
-        Publish "load" to minions. This send the load to the publisher daemon
-        process with does the actual sending to minions.
+    def pack_publish(self, load):
+        """
+        Package the "load" for a publish to minions. This send the load to the
+        publisher daemon process with does the actual sending to minions.
 
         :param dict load: A load to be sent across the wire to minions
-        '''
-        payload = {'enc': 'aes'}
-        crypticle = salt.crypt.Crypticle(self.opts, salt.master.SMaster.secrets['aes']['secret'].value)
-        payload['load'] = crypticle.dumps(load)
-        if self.opts['sign_pub_messages']:
-            master_pem_path = os.path.join(self.opts['pki_dir'], 'master.pem')
+        """
+        payload = {"enc": "aes"}
+        load["serial"] = salt.master.SMaster.get_serial()
+        crypticle = salt.crypt.Crypticle(
+            self.opts, salt.master.SMaster.secrets["aes"]["secret"].value
+        )
+        payload["load"] = crypticle.dumps(load)
+        if self.opts["sign_pub_messages"]:
+            master_pem_path = os.path.join(self.opts["pki_dir"], "master.pem")
             log.debug("Signing data packet")
             payload['sig'] = salt.crypt.sign_message(master_pem_path, payload['load'])
         int_payload = {'payload': self.serial.dumps(payload)}
@@ -1070,10 +1130,19 @@ class ZeroMQPubServerChannel(salt.transport.server.PubServerChannel):
             'Sending payload to publish daemon. jid=%s size=%d',
             load.get('jid', None), len(payload),
         )
+        return payload
+
+    def publish(self, load):
+        """
+        Publish "load" to minions. This send the load to the publisher daemon
+        process with does the actual sending to minions.
+
+        :param dict load: A load to be sent across the wire to minions
+        """
         if not self.pub_sock:
             self.pub_connect()
-        self.pub_sock.send(payload)
-        log.debug('Sent payload to publish daemon.')
+        self.pub_sock.send(self.serial.dumps(load))
+        log.debug("Sent payload to publish daemon.")
 
 
 class AsyncReqMessageClientPool(salt.transport.MessageClientPool):
diff --git a/salt/utils/minions.py b/salt/utils/minions.py
index b02ab34777..6995a29131 100644
--- a/salt/utils/minions.py
+++ b/salt/utils/minions.py
@@ -742,21 +742,28 @@ class CkMinions(object):
         return _res
 
     def validate_tgt(self, valid, expr, tgt_type, minions=None, expr_form=None):
-        '''
-        Return a Bool. This function returns if the expression sent in is
-        within the scope of the valid expression
-        '''
+        """
+        Validate the target minions against the possible valid minions.
+
+        If ``minions`` is provided, they will be compared against the valid
+        minions. Otherwise, ``expr`` and ``tgt_type`` will be used to expand
+        to a list of target minions.
 
-        v_minions = set(self.check_minions(valid, 'compound').get('minions', []))
+        Return True if all of the requested minions are valid minions,
+        otherwise return False.
+        """
+
+        v_minions = set(self.check_minions(valid, "compound").get("minions", []))
+        if not v_minions:
+            # There are no valid minions, so it doesn't matter what we are
+            # targeting - this is a fail.
+            return False
         if minions is None:
             _res = self.check_minions(expr, tgt_type)
             minions = set(_res['minions'])
         else:
             minions = set(minions)
-        d_bool = not bool(minions.difference(v_minions))
-        if len(v_minions) == len(minions) and d_bool:
-            return True
-        return d_bool
+        return minions.issubset(v_minions)
 
     def match_check(self, regex, fun):
         '''
